/***************************************************************************/
/* NoBorder v1.0 - makes screen as big as possible, then remove border and */
/*                 attached gadgets, more or less the same as Border v1.1  */
/*                 by Torsten Jueryeleit but intuition friendly so will    */
/*                 run with all versions of workbench. Also includes a     */
/*                 check for NTSC.                                         */
/*                                                                         */
/*  Author: Greg Hughes.                                                   */
/* Version: 1.1 (22/03/1993)                                               */
/*                                                                         */
/* This program is freeware. Written in Amiga E!!                          */
/***************************************************************************/

PROC main()
DEF swptr,ssptr,f

/* Formfeed, makes sure a window is present before try to mess with it */
f:=12
WriteF('\c',f)

/* Find current window, i.e. CLI window */
swptr := Long(intuitionbase+52)

/* Find current screen */
ssptr := Long(intuitionbase+56)


   /* Make Window.MinWidth & Window.MinHeight zero */
   PutLong(swptr+16,0)

   /* Move to 0,0 and make as small as possible */
   IF ( (Int(swptr+4) <> 0) OR (Int(swptr+6) <> 0) )
      MoveWindow(swptr,(0-Int(swptr+4)),(0-Int(swptr+6)))
   ENDIF
   SizeWindow(swptr,(1-Int(swptr+8)),(1-Int(swptr+10)))

   /* Window.Flags */  
   PutLong(swptr+24,2048)
   /* Window.Title */
   PutLong(swptr+32,0) 
   /* Window.Borders */
   PutLong(swptr+54,0)
   /* Window.FirstGadget */
   PutLong(swptr+62,0)

   /* Make as large as possible but now we should be borderless */
   SizeWindow(swptr,(Int(ssptr+12)-1),(Int(ssptr+14)-1) )
   /* Move In Front of other windows */
   WindowToFront(swptr)

/* If we haven't any arguments print out banner */
IF (StrLen(arg) = 0)
   WriteF('\e[1mNoBorder v1.1\e[0m  Greg Hughes 1993\n\n')
   WriteF('Makes current window as big as possible and removes border.\n')
   WriteF('Workbench 2.x+ & NTSC friendly!!\n')
   WriteF('execute command with argument to avoid this text.\n\n')
ENDIF

ENDPROC
